import urllib2
import os
os.chdir('C:\Users\christoff.jorgensen\Documents\Master\Python\Garmin')
from results_file import create_html, create_ID_list

def to_text(string, nameAndType):
    """Prints strings to a file. Accepts a string and filename.type"""
    with open(nameAndType, 'w') as f:
        f.write(string)


def table_to_text(table):
    """Prints a table to a text file. Requires a table"""
    with open('garmin.txt', 'a') as f:
        i = 0
        while i < len(table):
            f.write(str(table[i]) + '\n')
            i += 1

def get_ID(url):
    """Gets the route ID"""
    ID = url.split('/')[-1]
    return ID


def get_tcx(ID):
    Adress = 'http://connect.garmin.com/proxy/activity-service-1.1/tcx/activity/' + ID + '?full=true'
    tcx = urllib2.urlopen(Adress)
    to_text(tcx.read(), ID + '.tcx')


def get_gpx(ID):
    Adress = 'http://connect.garmin.com/proxy/activity-service-1.1/gpx/activity/' + ID + '?full=true'
    gpx = urllib2.urlopen(Adress)
    to_text(gpx.read(), ID + '.gpx')


def magic():
    """requires direct url to get tcx for one route"""
    metaData = []

    ##direct link to the wanted route
    url = raw_input('Enter URL: ')

    ##Get route ID. Purely text formatting
    ID = get_ID(url)

    ##Downloads .tcx (and .gpx) file and writes to "/master/python/Garmin/"
    get_tcx(ID)
    ##get_gpx(url)


    ##Appends url and id to a .txt
    metaData.append((url, ID))
    with open('Garmin.txt', 'a') as f:
        f.write(str(metaData[-1]) + '\n')


def magic2():
    metaData = []

    raw_input("Update input.txt with search result! Press enter when done.")

    create_html()
    IDList = create_ID_list()
    for item in IDList:
        get_tcx(str(item))
        url = "http://connect.garmin.com/activity/" + str(item)
        metaData.append((url, str(item)))
    
    table_to_text(metaData)
    

def true():
    """Endless loop used when gatering data. Runs the magic function"""
    while True:
        magic()

