##xml fra kartverket
import xml.etree.cElementTree as ET
import urllib2
import re
from os import chdir

chdir('C:\Users\christoff.jorgensen\Documents\Master\spss\Ny filterrunde 30.4.14')

def get_ele(data):
    """Parses xml file from kartverket"""
    tree = ET.parse(data)
    root = tree.getroot()

    
    for child in root:
        if re.sub(r'\{.*?\}', '', child.tag) == "ProcessOutputs":
            output = child
            
    for child in output:
        for children in child:
                if children.text == "elevation":
                    ele = child
                    
    for child in ele:
        if re.sub(r'\{.*?\}', '', child.tag) == "Data":
            eleData = child

    for child in eleData:
        if re.sub(r'\{.*?\}', '', child.tag) == "LiteralData":
            elevation = float(child.text)

    return elevation


def get_xml(lat, lon):
    """gets the xml file containing heightdata from kartverket"""
    """Might overload their services if many track points!!"""
    a = []
    a.append('http://openwps.statkart.no/skwms1/wps.elevation?request=Execute&service=WPS&version=1.0.0&identifier=elevation&datainputs=[lat=')
    a.append(str(lat))
    a.append(';lon=')
    a.append(str(lon))
    a.append(';epsg=4326]')
    url = ''.join(a)
    xml = urllib2.urlopen(url)
    
    return xml

def imp_csv():
    """Import csv"""
    points = []
    with open('lat_lon_alt.csv', 'r') as f:
        for line in f:
            points.append(line.strip('\n'))
    points.pop(0)
    return points


        
def exp_csv(table, filename):
    """Export csv"""
    print "Printing", filename
    with open(filename, 'w') as csvfile:
        export = writer(csvfile, dialect='excel-tab')
        export.writerows(table)

def append_to_file(points):
    with open("append_file.txt", 'a') as f:
        f.write(points)
    

def magic():
    points = imp_csv()

    for index, string in enumerate(points):
##        if index%1000 == 0:
        print index
        split = str(string).split(',')
        lat = float(split[0].strip('('))
        lon = float(split[1])
        alt_gps = float(split[2].strip(')'))
        xml = get_xml(lat, lon)
        alt_KV = get_ele(xml)
        points.append((lat, lon, alt_gps, alt_KV))
        append_to_file(points[-1])


    exp_csv(points, "lat_lon_altGPS_altKV.csv")
    
    
        
    
